package com.itheima.test;

import java.io.*;
import com.ibatis.db.util.ScriptRunner;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
/**
 * 
 * 描述:批量导入sql脚本
 * @author zhuan
 * @version 2018年10月26日 下午8:22:28
 */
public class MysqlFile {
	public static void main(String[] args) throws Exception {
		test("D:/mysql_sql", "mysql_sql");//调用测试方法，参数一：所有sql脚本所在文件夹路径 参数二：mysql数据库中“数据库”的名字
	}
	// 遍历
	private static void test(String fileDir, String dbname) throws Exception {
		List<File> fileList = new ArrayList<File>();//1.声明保存sql文件集合
		File file = new File(fileDir);//获取指定“文件夹”下所有 文件+文件夹
		File[] files = file.listFiles();
		if (files == null) {//如果文件为空直接返回
			return;
		}
		for (File f : files) {
			if (f.isFile()) {//文件不为空且为文件
				// 查找.sql结尾的文件
				int sql = f.getName().indexOf(".sql");
				if (sql != -1) {
					fileList.add(f);
				}
			} else if (f.isDirectory()) {//如果是文件夹，接着遍历文件夹下内容
				test(f.getAbsolutePath(), dbname);
			}

		}
		for (File f1 : fileList) {//遍历所有sql文件
			String s = f1.getAbsolutePath();
			readSQLFile(s, dbname);//执行sql脚本
		}
	}
	// 执行sql文件
	public static void readSQLFile(String path, String dbname) throws Exception {
		Map<String, String> paramMap = new HashMap<>();
		paramMap.put("driver", "com.mysql.jdbc.Driver");
		paramMap.put("url", "jdbc:mysql://localhost:3306/"+dbname+"?characterEncoding=utf-8");
		paramMap.put("username", "root");//用户名，密码也可以自己单独提取出去
		paramMap.put("password", "root");
		paramMap.put("stopOnError", "true");//设置错误停止
		paramMap.put("autoCommit", "false");
		ScriptRunner runner = new ScriptRunner(paramMap);
		runner.setLogWriter(null);
		runner.runScript(new InputStreamReader(new FileInputStream(path), "UTF-8"));
	}
}